import random
import time
import curses
start_time = time.time()
NUM_OF_ROUNDS = input('Rounds [10K]:\t')
if NUM_OF_ROUNDS == '':
    NUM_OF_ROUNDS = 10000
else:
    NUM_OF_ROUNDS = int(NUM_OF_ROUNDS)

GREEN = '\033[92m'
RED = '\033[1;31m'
ENDC = '\033[0m'


def status_bar(current_value, final_value, bar_size=40):
    percent = int((bar_size / 100) * int((current_value * 100) / final_value))
    return f'|{"#" * percent}{"=" * (bar_size - percent)}|'


def m_h_problem():
    doors = {'a': 0, 'b': 0, 'c': 0}
    car = random.choice(['a', 'b', 'c'])
    doors[car] = 1
    user_choice = random.choice(['a', 'b', 'c'])
    # Open door
    open_door = [i for i in ('a', 'b', 'c') if i not in (car, user_choice)]
    open_door = open_door[0]
    switch_choice = [i for i in ('a', 'b', 'c')
                     if i not in (open_door, user_choice)][0]
    random_choice = random.choice([user_choice, switch_choice])
    return (car, random_choice, switch_choice)


def color(exit, ch_1, ch_2):
    choices = (ch_1, ch_2)
    return (f'{GREEN}{i}{ENDC}'if i == exit else f'{RED}{i}{ENDC}' for i in choices)


def main():
    c_1 = 0
    c_2 = 0
    screen = curses.initscr()
    curses.curs_set(0)
    for i in range(1, NUM_OF_ROUNDS+1):
        car, random_choice, switch_choice = m_h_problem()
        if random_choice == car:
            c_1 += 1
        if switch_choice == car:
            c_2 += 1
        success_rates = (round((100.0 * c_1) / i, 1), round((100.0 * c_2) / i, 1))
        screen.addstr(0, 0, f'Rounds: {i}/{NUM_OF_ROUNDS}\tCar: {car}\tRandom choice: {random_choice}\tSwitch choice: {switch_choice}\nScore: {c_1}-{c_2}\tSuccess rates: {success_rates[0]}%-{success_rates[1]}%\n')
        screen.addstr(2, 0, status_bar(i, NUM_OF_ROUNDS))
        screen.refresh()
    stop_time = time.time()
    while True:
        curses.noecho()
        screen.addstr('\nPress Q to quit')
        c = screen.getch(1, 1)
        if c == ord('q') or c == ord('Q'):
            break
    curses.endwin()
    print(f'Score:\t\t{c_1}-{c_2}\nSuccess rates:\t{success_rates[0]}%-{success_rates[1]}%')
    print(f'Run time:\t{stop_time - start_time}')


if __name__ == "__main__":
    main()
